<template>
  <b-input-group class="mb-2">
    <template #prepend>
      <b-input-group-text><i-bi-search /></b-input-group-text>
    </template>
    <b-form-input
      v-model="searchString"
      debounce="1000"
      :placeholder="$t('searchVoc')"
    />
  </b-input-group>
</template>

<script lang="ts">
import { defineComponent } from "vue";

import serviceProvider from "@/util/service-providers/service-provider";

export default defineComponent({
  name: "SearchVoc",
  data() {
    return {
      searchString: "",
    };
  },
  watch: {
    searchString() {
      this.retrieveVocabs();
    },
  },
  created() {
    this.retrieveVocabs();
  },
  methods: {
    async retrieveVocabs() {
      this.$emit("searching", true);
      try {
        this.$emit(
          "vocabularyTerms",
          await serviceProvider.apiConnection.searchVocabularyTerms(
            this.searchString,
          ),
        );
      } finally {
        this.$emit("searching", false);
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
